@echo off

rem GiveAdministratorsFullPermission.bat
rem 2008-07-21
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal EnableDelayedExpansion

  set scriptDir=%~d0%~p0
  set scriptName=%~n0%~x0

  set path=%scriptDir%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% equ 0 (
    call :usage
  ) else (
    call :loop %*
  )

  goto :end

:loop
  rem Following statement needs double-quote to handle '&'.
  set object="%~1"

  rem Variable already contains double-quotes. Leave double-quote off.
  if %object% == "" goto :EOF

  rem Variable already contains double-quotes. Leave double-quote off.
  call SetVariableToOutput.bat IsFileMask.bat %object%
  if %OutputVariable% == 1 (
    for %%f in (%object%) do call GiveAdministratorsFullPermissionToFile.bat "%%f"
  ) else (
    rem Variable already contains double-quotes. Leave double-quote off.
    call GiveAdministratorsFullPermissionToFile.bat %object%
  )

  shift
  goto :loop

:usage
  echo   Usage: "%scriptName%" "file/dir 1" [ . . . "file/dir N" ] 1>&2
  goto :EOF

:end
