@echo off

rem Uninstall.bat
rem 2008-07-17
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL) Version 2, June 1991

  SetLocal

:: BatchGotAdmin
:-------------------------------------
  REM  --> Check for permissions
  set caclsExec=%SystemRoot%\System32\icacls.exe
  if not exist "%caclsExec%" set caclsExec=%SystemRoot%\System32\cacls.exe

  >nul 2>&1 "%caclsExec%" "%SYSTEMROOT%\system32\config\system"

  REM --> If error flag set, we do not have admin.
  if '%errorlevel%' NEQ '0' (
      echo Requesting administrative privileges...
      goto :UACPrompt
  ) else (
    goto :gotAdmin
  )

:UACPrompt
  rem Acquire the executable now,
  rem otherwise it will get shifted.
  set executable=%~s0
  set params=

:paramsLoop
  set arg=%~1
  if "%arg%" == "" goto :doneParams
  set params=%params% ""%arg%""
  shift
  goto :paramsLoop
:doneParams

  echo Set UAC = CreateObject ^("Shell.Application"^) > "%temp%\getadmin.vbs"
  echo UAC.ShellExecute "cmd.exe", "/c """"%executable%"" %params%""", "", "runas", 1 >> "%temp%\getadmin.vbs"

  "%temp%\getadmin.vbs"
  del "%temp%\getadmin.vbs"
  exit /B

:gotAdmin
:--------------------------------------

  set progDir=TakeControl
  set startMenuPath=%AllUsersProfile%\Start Menu\Programs\%progDir%

  set desktopPath=%SystemDrive%\Users\Public\Desktop
  if not exist "%desktopPath%" set desktopPath=%SystemDrive%\Users\All Users\Desktop
  if not exist "%desktopPath%" set desktopPath=%AllUsersProfile%\Desktop

  %~d0
  cd %~p0

  if exist "%progDir%" goto :completeRemoval
  goto :setupCompleteRemoval

:removeDirectory
  set dirPath=%~s1

  if exist "%dirPath%" (
    echo Removing "%dirPath%" . . .
    echo y | del "%dirPath%"
    rmdir "%dirPath%"
  )
  goto :EOF

:setupCompleteRemoval
  copy Uninstall.bat ..
  cd ..
  Uninstall.bat
  rem Will never get to this point, because
  rem process has been transfered.
  goto :end

:completeRemoval
  call :removeDirectory "%desktopPath%\%progDir%"
  call :removeDirectory "%SystemDrive%\Users\Public\Desktop\%progDir%"

  call :removeDirectory "%startMenuPath%"

  call :removeDirectory "%progDir%"

  del Uninstall.bat

  rem Batch file will output
  rem "The batch file cannot be found." here
  rem because it can't find itself to continue
  rem execution.

  goto :end

:end
