@echo off

rem ConsolePause.cmd
rem 2014-12-03
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

rem Localizes the final pause in all of the console
rem scripts in one spot, so that it can be easily
rem turned on and off.

  SetLocal EnableDelayedExpansion

  set scriptDir=%~d0%~p0
  set scriptName=%~n0%~x0

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% equ 0 (
    call :run %*
  ) else (
    call :usage
  )

  goto :end

:run
  pause
  goto :EOF

:usage
  echo   Usage:   "%scriptName%"
  goto :EOF

:end
