@echo off

rem PublicAccessAllContent.bat
rem 2008-10-21
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal

  set scriptPath=%~d0%~p0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% == 0 goto :help

  call :loop %*
  goto :end

:loop
  if ?%1? == ?? goto :EOF
  rem Following statement needs double-quote to handle '&'
  set spec="%~1"

  rem spec already contains double-quotes. Leave double-quote off.
  call SetVariableToOutput.bat IsDirectory.bat %spec%
  set result=%OutputVariable%

  rem spec already contains double-quotes. Leave double-quote off.
  if %result% == 1 call :processDir %spec%
  if %result% == 0 call :processFile %spec%

  shift
  goto :loop

:processDir
  set spec=%~1

  call PublicAccess.bat "%spec%"

rem For some reason, the following two statements doesn't do anything
rem even after permission has been granted with the prior line.
  for %%f in ("%spec%"\*) do call PublicAccess.bat "%%f"
  for /D %%d in ("%spec%"\*) do call PublicAccessAllContent.bat "%%d"

  rem Therefore, we process it again in a new shell.
  cmd /c PublicAccessAllContent.bat "%spec%"
  goto :EOF

:processFile
  set spec=%~1

  call PublicAccess "%spec%"
  goto :EOF

:help
  echo   Usage: "%~n0%~x0" "file/dir 1" [ . . . "file/dir N" ]

:end
